package com.bull.eclipse.jonas.actions;

/*
 * (c) Copyright Bull SA 2003.
 * All Rights Reserved.
 */

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import com.bull.eclipse.jonas.JonasLauncherPlugin;

public class StopActionDelegate implements IWorkbenchWindowActionDelegate {
	private IWorkbenchWindow window;

	/*
	 * @see IWorkbenchWindowActionDelegate#dispose()
	 */
	public void dispose() {
	}

	/*
	 * @see IWorkbenchWindowActionDelegate#init(IWorkbenchWindow)
	 */
	public void init(IWorkbenchWindow window) {
		this.window = window;
	}

	/*
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		JonasLauncherPlugin.log(JonasLauncherPlugin.getResourceString("msg.stop"));

		try {	
			JonasLauncherPlugin.getDefault().getJonasBootstrap().stop();
		} catch (Exception ex) {
			String msg = JonasLauncherPlugin.getResourceString("msg.stop.failed");
			JonasLauncherPlugin.log(msg + "/n");
			JonasLauncherPlugin.log(ex);	
		}
	}

	/*
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
	}

}

