package com.bull.eclipse.jonas.actions.ejb;

import java.beans.Introspector;
import java.io.File;
import java.util.Collection;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IImportDeclaration;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IJavaModel;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IPackageFragment;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.core.Signature;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.internal.core.JavaProject;
import org.eclipse.jdt.internal.core.PackageFragment;
import org.eclipse.jdt.internal.ui.JavaPlugin;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.preference.PreferenceContentProvider;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.dialogs.CheckedTreeSelectionDialog;
import org.eclipse.ui.dialogs.ListSelectionDialog;

import com.bull.eclipse.jonas.JonasLauncherPlugin;
import com.bull.eclipse.jonas.JonasPluginResources;
import com.bull.eclipse.jonas.JonasProject;
import com.bull.eclipse.jonas.actions.JonasPackageAbstractActionDelegate;
import com.bull.eclipse.jonas.utils.AntUtils;
import com.bull.eclipse.jonas.utils.EjbManagement;
import com.bull.eclipse.jonas.utils.UpdatePropsFile;
import com.bull.eclipse.jonas.utils.xml.FileXmlUtils;
import com.bull.eclipse.jonas.utils.xml.UpdateXmlFile;
import com.bull.eclipse.jonas.utils.xml.XMLUtils;
import com.bull.eclipse.newbean.FacadeEJBGenerate;
import com.bull.eclipse.newbean.EntityDescValue;
import com.bull.eclipse.newbean.FacadeValue;
import com.bull.eclipse.newbean.FkTableAndColumns;
import com.bull.eclipse.newbean.MethodDescValue;
import com.bull.eclipse.newbean.NewFacadeValue;



public class AggregateFacadeEjbActionDelegate extends JonasPackageAbstractActionDelegate
{
	static private Object[] oldSelection = null; 
	static private String oldBeanName = null;
	static private String suffixValue = "TO";
	static private int lengthSuffixValue = 2;
	
	public boolean doActionOn(IPackageFragment pack) throws Exception {
		// Update build.properties with JONAS_ROOT
		if (pack.containsJavaResources()) 
			throw new Exception("You must execute this function on a deployment unit !");
		
		JonasProject jp = (JonasProject)pack.getJavaProject().getProject().getNature(JonasLauncherPlugin.NATURE_ID);
		UpdatePropsFile.updatePropsProject(jp);		
		
		
		String projDir = jp.getProject().getLocation().toOSString();		
		String packName = pack.getPath().removeFirstSegments(1).toOSString();	
		File ejb_standard_xml = new File(projDir , pack.getPath().removeFirstSegments(1).append("ejb-jar.xml").toOSString());
		File ejb_jonas_xml = new File(projDir , pack.getPath().removeFirstSegments(1).append("jonas-ejb-jar.xml").toOSString());
		if ((!ejb_standard_xml.exists()) || (!ejb_jonas_xml.exists())) 
			throw new Exception("The deployment unit must be create by the middlegen functionnality");
				
		Hashtable hashtable = FileXmlUtils.getAllNameAndPackageEJBEntity(ejb_standard_xml);
		
		// Entities EJB name
		Vector vec = new Vector(hashtable.keySet());
		Vector entitiesChoice =  ejbEntitiesNameChoice(vec);
		Enumeration nameEnum = entitiesChoice.elements();
		Vector entitesChoicePackage = new Vector();
		while (nameEnum.hasMoreElements()) {
			entitesChoicePackage.add(hashtable.get(nameEnum.nextElement()));
		}
		Vector vecValue = new Vector();
		for (int i = 0; i < entitesChoicePackage.size(); i++) {
			EntityDescValue napv = new EntityDescValue();
			napv.setBeanName((String) entitiesChoice.get(i));
			napv.setPackageName((String) entitesChoicePackage.get(i));
			vecValue.add(napv);
		}
		
		vecValue = getMethods(vecValue,pack.getJavaProject(),jp);
		
		File tempFile = new File(jp.getProject().getLocation().append("temp").toOSString());
		if (!tempFile.exists())
    		tempFile.mkdirs();
		
		
		FacadeEJBGenerate feg = new FacadeEJBGenerate(jp);
		NewFacadeValue nfv = new NewFacadeValue();
		nfv.setVecValue(vecValue);
		//String beanName = getChoice(oldBeanName,"Facade EJB name","What is the facade ejb name ?");
		String beanName = "Persistence";
		oldBeanName = beanName;
		String firstChar = beanName.substring(0,1);
		String endString = beanName.substring(1,beanName.length());
		nfv.setBeanName(firstChar.toUpperCase().concat(endString));
		nfv.setPackageName(pack.getPath().removeFirstSegments(2).toOSString().replace(File.separatorChar, '.').concat(".persistenceservices"));

		nfv.setFacadeMethods(getFacadeEJBMethods(nfv.getBeanName(),jp,nfv.getPackageName(),pack.getJavaProject()));
		
		feg.runNewFacade(nfv);
		// Update standard deployment descriptor
		UpdateXmlFile.updateEjbStandardXmlFile(ejb_standard_xml, new File(tempFile, "facadeNode.xml"));
		UpdateXmlFile.updateEjbJOnASXmlFile(ejb_jonas_xml, new File(tempFile, "JOnASFacadeNode.xml"));
		
		jp.getProject().refreshLocal( IResource.DEPTH_INFINITE, null );			 
		
		
		
	    return false;
	}			

	private Vector ejbEntitiesNameChoice(Vector vecEjbName) throws Exception {
		final String[] listEJBEntity = (String[]) vecEjbName.toArray(new String[0]);
		ListSelectionDialog lsd =
			new ListSelectionDialog(
				PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),
				new Object(),
				new IStructuredContentProvider() {

			public void dispose() {
			}

			public Object[] getElements(Object inputElement) {
				return listEJBEntity;
			}

			public void inputChanged(Viewer viewer1, Object obj, Object obj1) {
				int i = 0;
			}

		}, new LabelProvider(), "Select entities beans you want to access by the ejb session");
		
		lsd.setTitle("Select j2ee modules");
		if (oldSelection == null) {
			lsd.setInitialSelections(listEJBEntity);	
		} else {
			lsd.setInitialSelections(oldSelection);
		}
		
		lsd.open();

		Object[] results_upd = lsd.getResult();
		
		oldSelection = results_upd;
		
		int ret = lsd.getReturnCode();
		// return null ( list of methods) , if user press cancel or nothing is selected 
		if (ret == 1)
			throw new Exception("Operation is cancelled");
		if ((results_upd == null) || (results_upd.length == 0))
			throw new Exception("There is no element to build the application");
		
		Vector entityChoice = new Vector();
		for(int i=0;i<oldSelection.length;i++) {
			entityChoice.add(oldSelection[i]);
		}

		return entityChoice;
	}
	
	private String getChoice(String defaultValue, String title_label, String label) {
		InputDialog id = new InputDialog(JavaPlugin.getActiveWorkbenchShell(),
				title_label,
				label, defaultValue, null);

		if (id.open() == org.eclipse.jface.window.Window.OK)
			return id.getValue();
		else
			return null;

	}

	protected static Vector getMethods(Vector vecValue, IJavaProject javp, JonasProject jp) throws JavaModelException {
		IPath ejbPath = jp.getProject().getLocation().append(jp.getSrcEJBDir());
		Vector napvVec = new Vector();
		for (int i=0; i < vecValue.size(); i++) {
			EntityDescValue napv = (EntityDescValue) vecValue.elementAt(i);
			IPath packFragPath = ejbPath.append(napv.getPackageName().replace('.',File.separatorChar));
			IPath classes = packFragPath.append(napv.getBeanName().concat("LocalHome.java"));
			String className = napv.getPackageName().concat(".").concat(napv.getBeanName()).concat("LocalHome");
			napv.setMethodHomeDesc(seekMethod(napv, className, javp));
			classes = packFragPath.append(napv.getBeanName().concat("Local.java"));
			className = napv.getPackageName().concat(".").concat(napv.getBeanName()).concat("Local");
			napv.setMethodDesc(seekMethod(napv, className, javp));

			napvVec.add(napv);
		}
		return napvVec;

	}
	
	private static Vector seekMethod(EntityDescValue napv, String className,
			IJavaProject japv) throws JavaModelException {
		IType ty = japv.findType(className);
		IMethod[] ime = ty.getMethods();
		Vector vecSignature = new Vector();
		MethodDescValue mdv = null;
		for (int j = 0; j < ime.length; j++) {
			if ((className
					.substring(className.length() - 5, className.length())
					.equals("Local")) 
					&& (!ime[j].getElementName().substring(0, 3).equals("set"))) {
				mdv = buildSignatureOnLocalInterface(ime[j], napv);
				if (mdv != null) 
					vecSignature.add(mdv);
			} else {
				mdv = buildSignatureOnLocalHomeInterface(ime[j], napv);
				if (mdv != null) 
					vecSignature.add(mdv);				
			}
		}
		

		return vecSignature;
	}

	public static MethodDescValue buildSignatureOnLocalInterface(IMethod ime, EntityDescValue napv) throws JavaModelException {
		MethodDescValue mdv = new MethodDescValue();
		String methodName = null;
		String signature = null;
		String parameterName = "";				
		if (ime.getElementName().substring(0,3).equals("add")) {
			methodName = napv.getBeanName().toLowerCase().concat("Add");
			mdv.setPkGetName(singularise(napv.getBeanName()));
			if (ime.getElementName().length() > 3) {
				String fkName = ime.getElementName().substring(ime.getElementName().lastIndexOf("By"),ime.getElementName().length());
				methodName = methodName.concat(fkName);
				mdv.setFkID(fkName);
				mdv.setAddMethodName(ime.getElementName().substring(3,ime.getElementName().length()));
			} else {
				mdv.setFkID("");
				mdv.setAddMethodName("");
			}
			String[] typeParams = ime.getParameterTypes();
			String[] nameParams = ime.getParameterNames();
			Vector vecParam = new Vector();
			for (int h = 0; h < typeParams.length; h++) {
				String param = Signature.toString(typeParams[h]);
				FkTableAndColumns ftac = new FkTableAndColumns();
				if (!param
						.substring(param.length() - lengthSuffixValue, param.length())
						.equals(suffixValue)) {
					String fkBeanName = param.substring(param
							.lastIndexOf(".") + 1, param.length() - 5);
					ftac.setFkTable(fkBeanName);
					String first = nameParams[h].substring(0,1).toUpperCase();
					ftac.setFkColumn(first.concat(nameParams[h].substring(1,nameParams[h].length())));
					vecParam.add(ftac);
				} else {
					mdv.setFkValueName(param.substring(param
							.lastIndexOf(".") + 1, param.length() - 5));
				}
			}
			mdv.setListLocalAdd(vecParam);
			signature = Signature.toString(ime.getReturnType());
			signature = signature + " ";
			signature = signature + methodName + "(";
			signature = signature + Signature.toString((ime.getParameterTypes())[0]) + " ";
			signature = signature + nameParams[0] + ")";
			mdv.setMethodName("add");
		} else {
			if ((ime.getElementName().substring(0, 3).equals("get"))) {
				if (!ime.getElementName().substring(
						ime.getElementName().length()-lengthSuffixValue,
						ime.getElementName().length()).equals(suffixValue)) {
					// On n'expose pas les mthodes get sur les cmp fields !!
					return null;
				}
						
				if (!(ime.getElementName().substring(
						3,ime.getElementName().length()-lengthSuffixValue)
						.equals(napv.getBeanName()))) {
					methodName = ime.getElementName().concat("Of")
							.concat(napv.getBeanName());
					signature = Signature.toString(ime
							.getReturnType())
							+ " "
							+ methodName
							+ "("
							+ napv.getTypePK()
							+ " pk)";
					parameterName = "pk";							
					mdv.setMethodName("get");
				} else {
					return null;
				}
					
			} else {
				methodName = ime.getElementName();
				signature = Signature.toString(ime.getSignature(),
						methodName, ime.getParameterNames(), true,
						true);
			}
		}
		String[] exceptionListe = ime.getExceptionTypes();
		String exception = " throws ";
		for (int g = 0; g < exceptionListe.length; g++) {
			if (!exception.equals(" throws "))
				exception = exception.concat(
						Signature.toString(exceptionListe[g])).concat(
						", ");
			else
				exception = exception.concat(
						Signature.toString(exceptionListe[g])).concat(
						", ");
		}
		mdv.setSignature(signature.concat(exception));
		mdv.setName(ime.getElementName());
		if (parameterName.equals("")) {
			String[] parameterNameList = ime.getParameterNames();
			for (int k = 0; k < parameterNameList.length; k++) {
				if (parameterName.equals(""))
					parameterName = parameterNameList[k];
				else
					parameterName = ", ".concat(parameterName);
			}
		}
		mdv.setParameterName(parameterName);
		return mdv;
	}

	public static MethodDescValue buildSignatureOnLocalHomeInterface(IMethod ime, EntityDescValue napv) throws JavaModelException {
		MethodDescValue mdv = new MethodDescValue();
		String methodName = null;
		String signature = null;
		String parameterName = "";				
		
		if (ime.getElementName().equals("findByPrimaryKey")) {
			napv.setTypePK(Signature.toString(ime
					.getParameterTypes()[0]));
			return null;
		} else if (ime.getElementName().equals("create")) {
			// On rcupre les paramtres dans le cas de FK
			String[] typeParams = ime.getParameterTypes();					
			Vector vecParam = new Vector();
			for(int h=0; h<typeParams.length; h++) {
				FkTableAndColumns ftac = new FkTableAndColumns();
				String param = Signature.toString(typeParams[h]);
				if (!param.substring(param.length()-lengthSuffixValue,param.length()).equals(suffixValue)) {
					String fkBeanName = param.substring(param.lastIndexOf(".")+1,param.length()-5);
					ftac.setFkTable(fkBeanName);
					parameterName = (ime.getParameterNames())[h];
					String first = parameterName.substring(0,1).toUpperCase();
					ftac.setFkColumn(first.concat(parameterName.substring(1,parameterName.length())));
					vecParam.add(ftac);
				}
			}
			napv.setListeFk(vecParam);
			return null;
		} else 	if (ime.getElementName().substring(0,4).equals("find")) {
			// On traite les mthodes find
			methodName = napv.getBeanName().toLowerCase().concat("find");
			String finderName = methodName.concat(ime.getElementName().substring(4));
			mdv.setName(ime.getElementName());
			String[] typeParams = ime.getParameterTypes();
			String[] nameParams = ime.getParameterNames();
			Vector vecParam = new Vector();
			signature = Signature.toString(ime.getReturnType());
			if (!signature.equals("java.util.Collection")) {
				signature = signature.substring(0,signature.length()-lengthSuffixValue).concat(suffixValue);
				mdv.setMethodName("value");
			}
			signature = signature + " ";
			signature = signature + Signature.toString(ime.getSignature(),finderName,nameParams,true,false);
			mdv.setSignature(signature);
			parameterName = "";
			for (int name=0;name<nameParams.length;name++) {
				if (parameterName.equals(""))
					parameterName = nameParams[name];
				else
					parameterName = parameterName + ", ".concat(nameParams[name]);
			}
			mdv.setParameterName(parameterName);
			return mdv;
		}
		return null;
	}

	public static Vector getFacadeEJBMethods(String facadeName,
			JonasProject jp, String duPackage, IJavaProject javaProj)
			throws JavaModelException {
		String sessionPackage = duPackage.replaceAll("entity", "session");
		String sessionFolder = sessionPackage.replace('.', File.separatorChar);
		File sessionFile = new File(jp.getProject().getLocation().append(
				jp.getSrcEJBDir()).toOSString(), sessionFolder);
		File ejbFile = new File(sessionFolder, facadeName + "FacadeEJB.java");

		Vector vec = new Vector();
		MethodDescValue mdv = null;
		IType ty = javaProj.findType(sessionPackage.concat(".").concat(
				facadeName).concat("FacadeEJB"));
		if (ty != null) {
			IMethod[] ime = ty.getMethods();
			for (int j = 0; j < ime.length; j++) {
				String type = ime[j].getSource().substring(0, 6);
				if (type.equals("public")) {
					mdv = new MethodDescValue();
					mdv.setName(ime[j].getElementName());
					String[] typeParams = ime[j].getParameterTypes();
					String[] nameParams = ime[j].getParameterNames();
					String signature = Signature.toString(ime[j]
							.getReturnType());
					signature = signature + " ";
					signature = signature
							+ Signature.toString(ime[j].getSignature(), mdv
									.getName(), nameParams, true, false);
					String[] exceptionListe = ime[j].getExceptionTypes();
					String exception = null;
					for (int g = 0; g < exceptionListe.length; g++) {
						if (exception == null)
							exception = " throws ".concat(Signature
									.toString(exceptionListe[g]));
						else
							exception = exception.concat(", ".concat(Signature
									.toString(exceptionListe[g])));
					}
					mdv.setSignature(signature.concat(exception));
					vec.add(mdv);
				}
			}
		}
		return vec;

	}
	
    public static String singularise(String name) {
		String result = name;
		if (seemsPluralised(name)) {
			String lower = name.toLowerCase();
			if (lower.endsWith("ies")) {
				// cities --> city
				result = name.substring(0, name.length() - 3) + "y";
			} else if (lower.endsWith("ches") || lower.endsWith("ses")) {
				// switches --> switch or buses --> bus
				result = name.substring(0, name.length() - 2);
			} else if (lower.endsWith("s")) {
				// customers --> customer
				result = name.substring(0, name.length() - 1);
			}
		}
		return result;
	}

    private static boolean seemsPluralised(String name) {
        name = name.toLowerCase();
        boolean pluralised = false;
        pluralised |= name.endsWith("es");
        pluralised |= name.endsWith("s");
        pluralised &= !(name.endsWith("ss") || name.endsWith("us"));
        return pluralised;
    }

}

