package com.bull.eclipse.jonas.actions.ejb;

import java.io.File;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import org.eclipse.core.resources.IResource;
import org.eclipse.jdt.core.IPackageFragment;

import com.bull.eclipse.jonas.JonasLauncherPlugin;
import com.bull.eclipse.jonas.JonasProject;
import com.bull.eclipse.jonas.actions.JonasPackageAbstractActionDelegate;
import com.bull.eclipse.jonas.utils.AntUtils;
import com.bull.eclipse.jonas.utils.EjbManagement;
import com.bull.eclipse.jonas.utils.UpdatePropsFile;
import com.bull.eclipse.jonas.utils.xml.FileXmlUtils;
import com.bull.eclipse.jonas.utils.xml.UpdateXmlFile;
import com.bull.eclipse.jonas.utils.xml.XMLUtils;
import com.bull.eclipse.newbean.FacadeEJBGenerate;
import com.bull.eclipse.newbean.EntityDescValue;
import com.bull.eclipse.newbean.NewFacadeValue;



public class BuildFacadeEjbActionDelegate extends JonasPackageAbstractActionDelegate
{

	public boolean doActionOn(IPackageFragment pack) throws Exception {
		// Update build.properties with JONAS_ROOT
		if (pack.containsJavaResources()) 
			throw new Exception("You must execute this function on a deployment unit !");
		
		JonasProject jp = (JonasProject)pack.getJavaProject().getProject().getNature(JonasLauncherPlugin.NATURE_ID);
		UpdatePropsFile.updatePropsProject(jp);		
		
		String projDir = jp.getProject().getLocation().toOSString();		
		String packName = pack.getPath().removeFirstSegments(1).toOSString();		
		File ejb_standard_xml = new File(projDir , pack.getPath().removeFirstSegments(1).append("ejb-jar.xml").toOSString());
		File ejb_jonas_xml = new File(projDir , pack.getPath().removeFirstSegments(1).append("jonas-ejb-jar.xml").toOSString());
		if ((!ejb_standard_xml.exists())  || (!ejb_jonas_xml.exists())) 
			throw new Exception("The deployment unit must be create by the middlegen functionnality");
		
		Hashtable hashtable = FileXmlUtils.getAllNameAndPackageEJBEntity(ejb_standard_xml);
		Enumeration nameEnum = hashtable.keys();
		Enumeration packageNameEnum = hashtable.elements();
		File tempFile = new File(jp.getProject().getLocation().append("temp").toOSString());
		if (!tempFile.exists())
    		tempFile.mkdirs();
		while (nameEnum.hasMoreElements()) {
			String packageName = (String) packageNameEnum.nextElement();
			String name = (String) nameEnum.nextElement();
			FacadeEJBGenerate feg = new FacadeEJBGenerate(jp);
			NewFacadeValue nfv = new NewFacadeValue();
			nfv.setBeanName(name);
			nfv.setPackageName(packageName);
			EntityDescValue napv = new EntityDescValue();
			napv.setBeanName(name);
			napv.setPackageName(packageName);			
			Vector vecValue = new Vector();
			vecValue.add(napv);
			vecValue = AggregateFacadeEjbActionDelegate.getMethods(vecValue,pack.getJavaProject(),jp);
			nfv.setVecValue(vecValue);
			feg.runNewFacade(nfv);
			// Update standard deployment descriptor
			UpdateXmlFile.updateEjbStandardXmlFile(ejb_standard_xml, new File(tempFile, "facadeNode.xml"));
			UpdateXmlFile.updateEjbJOnASXmlFile(ejb_jonas_xml, new File(tempFile, "JOnASFacadeNode.xml"));

		}
		
		
		jp.getProject().refreshLocal( IResource.DEPTH_INFINITE, null );			 
		
		
		
	    return false;
	}			

}

