package com.bull.eclipse.jonas.actions.ejb;


import java.util.Properties;
import java.util.Vector;

import com.bull.eclipse.jonas.JonasLauncherPlugin;
import com.bull.eclipse.jonas.JonasProject;
import com.bull.eclipse.jonas.actions.JonasProjectAbstractActionDelegate;
import com.bull.eclipse.jonas.utils.AntUtils;
import com.bull.eclipse.jonas.utils.UpdatePropsFile;
import com.bull.eclipse.newbean.JopeUpdateBean;



public class ExportJarActionDelegate extends JonasProjectAbstractActionDelegate
{

	public boolean doActionOn(JonasProject prj) throws Exception {
		// Update build.properties with JONAS_ROOT
		Properties props = new Properties();
		props.setProperty("jonas.root", JonasLauncherPlugin.getDefault().getJonasDir());
		UpdatePropsFile.updatePropsProject(prj);		

		
		String jonasRoot = JonasLauncherPlugin.getDefault().getJonasDir();
		Vector pkgListe = prj.getPackageProjectFolder();
		if (pkgListe == null) {
			throw new Exception("There is no EJB");
		} else if (pkgListe.isEmpty()) {
			throw new Exception("There is no EJB");
		}
		JopeUpdateBean jub = new JopeUpdateBean(pkgListe,prj);
		jub.generate();

		AntUtils.runAnt(prj.getProject().getFullPath().append(prj.getSrcEJBDir()).append("/build.xml").toOSString());

		//TODO Deploy EJB
		/*
		Vector jarName = prj.getJarEjbName();
		Enumeration e = jarName.elements();
		while (e.hasMoreElements()){ 
			DeployEjbActionDelegate.deploy((String)e.nextElement() + ".jar");
		}
		*/
		
	    return false;
	}			


	/**
	 * Create a new array : [ s1, s2, s3 ]
	 * (TODO move this method to StringUtil)
	 */
	public static String[] concat( String[] s1, String s2, String s3 )
	{
		String[] full = new String[ s1.length + 2 ];
		System.arraycopy( s1, 0, full, 0, s1.length );
		full[ full.length-2 ] = s2;
		full[ full.length-1 ] = s3;
		return full;	
	}

	/**
	 * Create a new array : [ s1, s2 ]
	 * (TODO move this method to StringUtil)
	 */
	public static String[] concat( String[] s1, String s2 )
	{
		String[] full = new String[ s1.length + 1 ];
		System.arraycopy( s1, 0, full, 0, s1.length );
		full[ full.length-1 ] = s2;
		return full;	
	}

}

