/*
 * Created on 9 fvr. 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.bull.eclipse.jonas.actions.middlegen;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Properties;

import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.jdt.internal.ui.JavaPlugin;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.preference.IPreferenceStore;

import com.bull.eclipse.jonas.JonasLauncherPlugin;
import com.bull.eclipse.jonas.JonasPluginResources;
import com.bull.eclipse.jonas.JonasProject;
import com.bull.eclipse.jonas.actions.JonasProjectAbstractActionDelegate;
import com.bull.eclipse.jonas.utils.AntUtils;
import com.bull.eclipse.jonas.utils.FileUtil;
import com.bull.eclipse.jonas.utils.TemplateDirUtil;

/**
 * @author riase
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public abstract class MiddlegenActionAbstract extends JonasProjectAbstractActionDelegate {
	JonasProject prj = null;
	File middleGenDir = null;
	String tempMiddlegen = null;
	String packageEntityEJB = null;
	String pathPackageBusiness = null;
	String pathPackageEntity = null;
	String ejbName = null;
	static private String persistenceDir = "persistence";
	
	public void copyConfigurationFile(String origin, String destination) throws IOException {
		IPath prjPath = prj.getProject().getLocation();
		middleGenDir = new File(prjPath.append(destination).toOSString());
		tempMiddlegen = TemplateDirUtil.getTemplateDir().concat(File.separator).concat("middlegen");
		if (!middleGenDir.exists())
			middleGenDir.mkdir();
//		File middleGenEJBDir = new File(prjPath.append(origin).append("src").append(prj.getProject().getName().toLowerCase() + "-prefs.properties").toOSString());
//		if (middleGenEJBDir.exists())
//			FileUtil.copy(middleGenEJBDir, new File(middleGenDir,"src" + File.separator + prj.getProject().getName().toLowerCase() + "-prefs.properties"));
	}

	public void createPropertiesFile(String persistence) throws IOException, CoreException {
		File buildProp = new File(middleGenDir, "build.properties");		
		if (!buildProp.exists()) {
			FileUtil.copy(new File(tempMiddlegen,"build.properties"),buildProp);					
			FileUtil.copy(new File(tempMiddlegen,"build.xml"),new File(middleGenDir,"build.xml"));
		}
		FileInputStream fis = new FileInputStream(buildProp);
		Properties props = new Properties();
		props.load(fis);
		fis.close();
		String defaultValue = props.getProperty("package.business");
		props.setProperty("jonas.root", JonasLauncherPlugin.getDefault().getJonasDir());
		props.setProperty("middlegen.lib", TemplateDirUtil.getTemplateDir().concat("/middlegen").concat("/lib"));
		props.setProperty("velocity.lib", TemplateDirUtil.getTemplateDir().concat("/.."));
		props.setProperty("name", prj.getProject().getName().toLowerCase());
		props.setProperty("persistence", persistence);
		String packageEntity = getEjbPackage(defaultValue);
		pathPackageBusiness = packageEntity.replace('.',File.separatorChar);
		props.setProperty("package.business",packageEntity);
		packageEntityEJB = packageEntity;
		pathPackageEntity = packageEntityEJB.replace('.',File.separatorChar);
		ejbName = packageEntityEJB.replace('.','_');

		props.setProperty("package.entity",packageEntityEJB);
		props.setProperty("path.package.entity",pathPackageEntity);
		IPath srcPersistenceDir = prj.getProject().getLocation().append(prj.getSrcPersistenceDir());
		if (!srcPersistenceDir.toFile().exists()) {
			srcPersistenceDir.toFile().mkdir();
			prj.setSrcAsSourceFolder(prj.getSrcPersistenceDir());
		}
		props.setProperty("gen.src.dir", srcPersistenceDir.toOSString());
		IPreferenceStore pref =	JonasLauncherPlugin.getDefault().getPreferenceStore();
		props.setProperty("database.url", pref.getString("url"));
		props.setProperty("datasource.jndi.name", pref.getString("datasource"));
		props.setProperty("database.driver", pref.getString("driver"));
		props.setProperty("database.userid", pref.getString("user"));
		props.setProperty("database.password", pref.getString("password"));
		props.setProperty("database.driver.classpath", pref.getString("jdbcDriver"));
		props.setProperty("database.schema", pref.getString("schema"));
		props.setProperty("database.catalog", pref.getString("catalog"));
		FileOutputStream fos = new FileOutputStream(buildProp);
		props.store(fos,null);		
		fos.close();
		prj.getProject().refreshLocal( IResource.DEPTH_INFINITE, null );			 
		prj.setPackageProjectFolder(packageEntityEJB);
		prj.setJarEjbName(ejbName);

	}
	
	public void startIHM(String target) {
		String path = prj.getProject().getName().concat(File.separator).concat(middleGenDir.getName()).concat(File.separator).concat("build.xml");		
		AntUtils.runAnt(path, target);
	}

	public void generateBuildWithVelocity() throws Exception {
		//Build file creation
		VelocityContext vContext = new VelocityContext();
		VelocityEngine vEngine = null;
		
		//On calcule le nombre de fragments du package
		String fragment = "../..";
		for (int i=0;i<packageEntityEJB.length();i++) {
			if (packageEntityEJB.charAt(i) == ".".charAt(0)) {
				fragment = fragment.concat("/..");
			}
		}
		vContext.put("relatifProjet",fragment);				
		vContext.put("pkgNameJava",pathPackageEntity);
		vContext.put("pkgNameJavaBusiness",pathPackageBusiness);
		vContext.put("jarName",ejbName);
		
		String jonasRoot = JonasLauncherPlugin.getDefault().getJonasDir();
		
		// Generates webapps files
		try {
			vEngine = new VelocityEngine();
			vEngine.setProperty(VelocityEngine.VM_LIBRARY, "");
			vEngine.setProperty(VelocityEngine.RESOURCE_LOADER, "file");
			vEngine.setProperty(VelocityEngine.FILE_RESOURCE_LOADER_PATH,
							TemplateDirUtil.getTemplateDir().concat("/middlegen"));
			try {
				vEngine.init();
			} catch (Exception e) {
				throw new Exception("unable to initilise Velocity engine (" + e + ")");
			}
			File duDir = new File(prj.getProject().getLocation().append(persistenceDir).append(pathPackageEntity).toOSString());			
			if (!duDir.exists())
				duDir.mkdirs();
			if (!prj.getProject().getLocation().append(persistenceDir).append(pathPackageEntity).append("build.xml").toFile().exists())
				generate("build.vm", prj.getProject().getLocation().append(persistenceDir).append(pathPackageEntity).append("build.xml").toOSString(),vEngine,vContext);            			
		} catch (Exception e) {        	
			throw new Exception(e.toString());
		}
		
		prj.getProject().refreshLocal( IResource.DEPTH_INFINITE, null );			 

	}
	
	
	public String getEjbPackage(String defaultValue) {
		InputDialog id = new InputDialog(JavaPlugin.getActiveWorkbenchShell(),
				JonasPluginResources.EJB_PACKAGE_TITLE_LABEL,
				JonasPluginResources.EJB_PACKAGE_MESSAGE_LABEL, defaultValue, null);

		if (id.open() == org.eclipse.jface.window.Window.OK)
			return id.getValue();
		else
			return null;

	}
	
	 private void generate(String templateFileName, String targetFileName,
			VelocityEngine vEngine, VelocityContext vContext) throws Exception,
			IOException, ResourceNotFoundException, ParseErrorException,
			MethodInvocationException {
		FileWriter fileWriter = null;
		fileWriter = new FileWriter(targetFileName);
		vEngine.mergeTemplate(templateFileName, vContext, fileWriter);
		fileWriter.close();
	}


}
