package com.bull.eclipse.jonas.actions.persistence;

import java.io.File;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import org.eclipse.core.resources.IResource;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IPackageFragment;
import org.eclipse.jdt.internal.core.PackageFragmentRoot;

import com.bull.eclipse.jonas.JonasLauncherPlugin;
import com.bull.eclipse.jonas.JonasProject;
import com.bull.eclipse.jonas.actions.JonasPackageAbstractActionDelegate;
import com.bull.eclipse.jonas.actions.JonasPackageRootAbstractActionDelegate;
import com.bull.eclipse.jonas.actions.ejb.AggregateFacadeEjbActionDelegate;
import com.bull.eclipse.jonas.actions.hibernate.PersistenceServicesValue;
import com.bull.eclipse.jonas.actions.persistence.utils.PersistencePackage;
import com.bull.eclipse.jonas.utils.AntUtils;
import com.bull.eclipse.jonas.utils.EjbManagement;
import com.bull.eclipse.jonas.utils.UpdatePropsFile;
import com.bull.eclipse.jonas.utils.xml.FileXmlUtils;
import com.bull.eclipse.jonas.utils.xml.UpdateXmlFile;
import com.bull.eclipse.jonas.utils.xml.XMLUtils;
import com.bull.eclipse.newbean.FacadeEJBGenerate;
import com.bull.eclipse.newbean.EntityDescValue;
import com.bull.eclipse.newbean.NewFacadeValue;
import com.bull.eclipse.persitence.EJB3ServicePersistenceGenerate;



public class PersistenceAPIActionDelegate extends JonasPackageRootAbstractActionDelegate
{

	public boolean doActionOn(PackageFragmentRoot packageRoot) throws Exception {
		// Update build.properties with JONAS_ROOT
		if (!"persistence".equals(packageRoot.getElementName())) 
			throw new Exception("You must execute this function on the persistence folder !");
		
		JonasProject jp = (JonasProject)packageRoot.getJavaProject().getProject().getNature(JonasLauncherPlugin.NATURE_ID);
		UpdatePropsFile.updatePropsProject(jp);		
		
		String projDir = jp.getProject().getLocation().toOSString();		
		String packName = packageRoot.getPath().removeFirstSegments(1).toOSString();

		String packagePersistence = PersistencePackage.getPersistencePackage(packageRoot.getChildren());
		PersistenceValue psv = new PersistenceValue();
		psv.setPersistencePackage(packagePersistence);
		psv.setPersistenceName("EntityManager");
		psv.setQueryInterfaceName("Query");
		
		
		EJB3ServicePersistenceGenerate espg = new EJB3ServicePersistenceGenerate(jp);
		espg.generateServicePersistence(psv);
		
		jp.getProject().refreshLocal( IResource.DEPTH_INFINITE, null );			 
		
		
		
	    return false;
	}			

}

