package com.bull.eclipse.jonas.utils.xml.desc;



/**
 * This class defines the declarations of DTDs for ejbjar.xml and jonas-ejbjar.xml
 * @author Philippe Coq
 */
public class HibernateDTDs extends CommonsDTDs {

    /**
     * List of hibernate  dtds
     */
    private static final String[] HIBERNATE_DTDS = new String[] {
        "hibernate-mapping-2.0.dtd",
        "hibernate-configuration-2.0.dtd",
        "hibernate-generic.dtd"
    };

    /**
     * List of hibernate  publicId
     */
    private static final String[] HIBERNATE_DTDS_PUBLIC_ID = new String[] {
        "-//Hibernate/Hibernate Mapping DTD 2.0//EN",
        "-//Hibernate/Hibernate Configuration DTD//EN",
		"-//Hibernate/Hibernate generic XML databinding format//EN"
    };




    /**
     * Build a new object for web.xml DTDs handling
     */ 
    public HibernateDTDs() {
        super();
        addMapping(HIBERNATE_DTDS, HIBERNATE_DTDS_PUBLIC_ID);
    }

}
