/*
 * Created on 14 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */ 
 
 
package com.bull.eclipse.jonas.wizard;

import java.util.ArrayList;
import java.util.Iterator;

import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.jdom.DOMFactory;
import org.eclipse.jdt.core.jdom.IDOMMethod;
import org.eclipse.jdt.core.search.IJavaSearchScope;
import org.eclipse.jdt.core.search.SearchEngine;
import org.eclipse.jdt.internal.ui.dialogs.TypeSelectionDialog;
import org.eclipse.jface.dialogs.ProgressMonitorDialog;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Text;

// Referenced classes of package com.objectlearn.jdt.j2ee.ui.wizards:
//            NewParamaterDialog, NewMethodDialog

public class AddEjbMethodWizardPage extends WizardPage {

	private Text signature;
	private Text name;
	private Text methodNameTxt;
	private Text methodNameTxt0;

	private Combo returnType;
	private Combo parsType;
	private Table parameters;
	private IDOMMethod method;
	private String methodType;
	private String interfaceType;
	private SearchEngine engine;
	private IWorkspace workSpace;
	private IJavaSearchScope scope;
	private List lisTotPars;
	private Combo lisPars;
	private String methodPublic;
	private String methodName;

	private interface Selector {

		public abstract void setSelection(Object obj);
	}

	private class TypeSelectionListener implements SelectionListener {

		public void widgetSelected(SelectionEvent event) {
			selector.setSelection(selection);
		}

		public void widgetDefaultSelected(SelectionEvent event) {
			selector.setSelection(selection);
		}

		private Object selection;
		private Selector selector;

		public TypeSelectionListener(
			Object newSelection,
			Selector newSelector) {
			selection = newSelection;
			selector = newSelector;
		}
	}

	public AddEjbMethodWizardPage(String pageName) {

		super(pageName);

		name = null;
		signature = null;
		returnType = null;
		parsType = null;
		parameters = null;
		method = null;
		methodType = "business";
		interfaceType = "remote";
		engine = new SearchEngine();
		workSpace = ResourcesPlugin.getWorkspace();
		scope = SearchEngine.createWorkspaceScope();
		setTitle("Add Business Methods .... ");
		setDescription("Add New Business Methods");
		method = (new DOMFactory()).createMethod();
		methodPublic = "public";
		methodName = null;
	}

	public void createControl(Composite parent) {
		Composite composite = new Composite(parent, 0);
		int nColumns = 4;
		GridLayout layout = new GridLayout();
		layout.numColumns = nColumns;
		composite.setLayout(layout);
		createMethodNameControls(composite, nColumns);
		createMethodTypeSelectionControls(composite, nColumns);
		createMethodPublicControls(composite, nColumns);
		createReturnTypeControls(composite, nColumns);
		createParameterControls(composite, nColumns);
		setControl(composite);
	}

	protected void createMethodTypeSelectionControls(
		Composite composite,
		int nColumns) {
		Selector methodTypeSelector = new Selector() {

			public void setSelection(Object selected) {
				methodType = (String) selected;

				methodNameTxt.setEnabled(methodType.equals("business"));
				methodNameTxt0.setEnabled(methodType.equals("find"));

				buildSignature();
			}

		};
		Group ejbType = new Group(composite, 0);
		ejbType.setLayout(new GridLayout());
		GridData gd = new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING);
		//		gd.horizontalSpan = nColumns;
		ejbType.setLayoutData(gd);
		ejbType.setText("Method Type");

		Group toto = new Group(ejbType, 0);
		GridLayout layout = new GridLayout();
		layout.numColumns = nColumns;

		toto.setLayout(layout);

		//GridData gdt = new GridData(GridData.HORIZONTAL_ALIGN_FILL | GridData.GRAB_HORIZONTAL);
		//gdt.horizontalSpan = nColumns / 2;

		gd.horizontalSpan = nColumns / 2;

		Button intButton = new Button(toto, 16);
		intButton.setText("Business Method");
		intButton.addSelectionListener(
			new TypeSelectionListener("business", methodTypeSelector));

		(new Label(toto, 0)).setText("Name");
		gd = new GridData(100);
		//		gd.horizontalSpan = nColumns - 2;
		methodNameTxt = new Text(toto, 2048);
		methodNameTxt.setLayoutData(gd);
		methodNameTxt.addModifyListener(new ModifyListener() {

			public void modifyText(ModifyEvent e) {
				buildSignature();
			}

		});

		Button fndButton = new Button(toto, 16);
		fndButton.setText("Find");
		fndButton.addSelectionListener(
			new TypeSelectionListener("find", methodTypeSelector));
		(new Label(toto, 0)).setText("Name");
		gd = new GridData(100);
		//		gd.horizontalSpan = nColumns - 2;
		methodNameTxt0 = new Text(toto, 2048);
		methodNameTxt0.setLayoutData(gd);
		methodNameTxt0.addModifyListener(new ModifyListener() {

			public void modifyText(ModifyEvent e) {
				buildSignature();
			}

		});

		Button createButton = new Button(toto, 16);
		createButton.setText("Create Method");
		createButton.addSelectionListener(
			new TypeSelectionListener("create", methodTypeSelector));
		intButton.setSelection(true);
		methodNameTxt.setEnabled(true);
		methodNameTxt0.setEnabled(false);

	}

	protected void createMethodPublicControls(
		Composite composite,
		int nColumns) {
		Selector methodTypeSelector = new Selector() {

			public void setSelection(Object selected) {
				methodPublic = (String) selected;
				buildSignature();
			}

		};
		Group ejbType = new Group(composite, 0);
		ejbType.setLayout(new GridLayout());
		GridData gd = new GridData(256);
		gd.horizontalSpan = nColumns / 2;
		ejbType.setLayoutData(gd);
		ejbType.setText("Method Scope");

		Button priButton = new Button(ejbType, 16);
		priButton.setText("Private");
		priButton.addSelectionListener(
			new TypeSelectionListener("private", methodTypeSelector));

		Button pubButton = new Button(ejbType, 16);
		pubButton.setText("Public");
		pubButton.addSelectionListener(
			new TypeSelectionListener("public", methodTypeSelector));

		Button proButton = new Button(ejbType, 16);
		proButton.setText("Protected");
		proButton.addSelectionListener(
			new TypeSelectionListener("protected", methodTypeSelector));
		pubButton.setSelection(true);
	}

	private GridData buttonLayout(Button button) {
		GridData data = new GridData(256);
		data.heightHint = 20;
		data.widthHint = 60;
		return data;
	}

	protected void createMethodNameControls(
		Composite composite,
		int nColumns) {
		GridLayout layout = new GridLayout();
		layout.numColumns = nColumns;
		Composite methodNameGroup = new Composite(composite, 0);
		methodNameGroup.setLayout(layout);
		GridData gd = new GridData(768);
		gd.horizontalSpan = nColumns;
		methodNameGroup.setLayoutData(gd);
		(new Label(methodNameGroup, 0)).setText("Method Signature");
		gd = new GridData(768);
		gd.horizontalSpan = nColumns - 2;
		name = new Text(methodNameGroup, 2048);
		name.setLayoutData(gd);

	}

	protected void createReturnTypeControls(
		Composite composite,
		int nColumns) {
		ArrayList primtypes = new ArrayList();

		primtypes.add("boolean");
		primtypes.add("byte");
		primtypes.add("char");
		primtypes.add("int");
		primtypes.add("long");
		primtypes.add("float");
		primtypes.add("double");

		primtypes.add("java.lang.Boolean");
		primtypes.add("java.lang.Character");
		primtypes.add("java.lang.Byte");
		primtypes.add("java.lang.Double");
		primtypes.add("java.lang.Float");
		primtypes.add("java.lang.FloatingDecimal");
		primtypes.add("java.lang.Integer");
		primtypes.add("java.lang.Long");
		primtypes.add("java.lang.Number");
		primtypes.add("java.lang.Short");
		primtypes.add("java.lang.String");
		primtypes.add("java.util.Collection");

		GridLayout layout = new GridLayout();
		layout.numColumns = nColumns;
		Composite returnTypeGroup = new Composite(composite, 0);
		returnTypeGroup.setLayout(layout);
		GridData gd = new GridData(768);
		gd.horizontalSpan = nColumns;
		returnTypeGroup.setLayoutData(gd);
		(new Label(returnTypeGroup, 0)).setText("Return Type");
		returnType = new Combo(returnTypeGroup, 2048);
		gd = new GridData(768);
		gd.horizontalSpan = nColumns - 3;
		returnType.setLayoutData(gd);
		returnType.add("void");
		for (Iterator iter = primtypes.iterator();
			iter.hasNext();
			returnType.add((String) iter.next()));
		returnType.addModifyListener(new ModifyListener() {

			public void modifyText(ModifyEvent e) {
				setErrorMessage(null);
				setPageComplete(true);
				buildSignature();
			}

		});
		Button selectType = new Button(returnTypeGroup, 0);
		selectType.setText("Browse");
		selectType.setLayoutData(buttonLayout(selectType));
		selectType.addSelectionListener(new SelectionListener() {

			private void doEvent(SelectionEvent e) {
				org.eclipse.swt.widgets.Shell parent = getShell();
				TypeSelectionDialog dialog =
					new TypeSelectionDialog(
						parent,
						new ProgressMonitorDialog(parent),
						6,
						SearchEngine.createWorkspaceScope());
				dialog.setTitle("Select Type");
				dialog.setMessage("Select Type");
				if (dialog.open() != 0) {
					return;
				} else {
					IType type = (IType) dialog.getResult()[0];
					returnType.setText(type.getFullyQualifiedName());
					return;
				}
			}

			public void widgetSelected(SelectionEvent e) {
				doEvent(e);
			}

			public void widgetDefaultSelected(SelectionEvent e) {
				doEvent(e);
			}

		});
	}

	protected void createParameterControls(Composite composite, int nColumns) {

		GridLayout layout = new GridLayout();
		layout.numColumns = nColumns;
		Group parametersGroup = new Group(composite, 0);
		parametersGroup.setLayout(layout);

		GridData gd = new GridData(768);
		gd.horizontalSpan = nColumns;
		parametersGroup.setLayoutData(gd);
		parametersGroup.setText("Method Parameters");

		final Button clearButton = new Button(parametersGroup, 0);
		final Button removeButton = new Button(parametersGroup, 0);
		final Button addButton = new Button(parametersGroup, 0);

		clearButton.setEnabled(false);
		removeButton.setEnabled(false);
		addButton.setEnabled(false);

		(new Label(parametersGroup, 0)).setText("Param. Type");

		lisPars = new Combo(parametersGroup, 2052);
		lisPars.addModifyListener(new ModifyListener() {

			public void modifyText(ModifyEvent e) {
				setErrorMessage(null);
				setPageComplete(true);
				addButton.setEnabled(!lisPars.getText().equals(""));
			}

		});

		gd = new GridData(768);
		gd.horizontalSpan = nColumns;
		lisPars.setLayoutData(gd);

		clearButton.setText("Clear");
		clearButton.setLayoutData(buttonLayout(clearButton));
		clearButton.addSelectionListener(new SelectionListener() {

			public void widgetSelected(SelectionEvent e) {
				lisTotPars.removeAll();
				boolean bvis = (lisTotPars.getItemCount() != 0);
				clearButton.setEnabled(bvis);
				removeButton.setEnabled(bvis);
				buildSignature();

			}

			public void widgetDefaultSelected(SelectionEvent e) {
				lisTotPars.removeAll();
			}

		});

		removeButton.setText("Remove");
		removeButton.setLayoutData(buttonLayout(removeButton));
		removeButton.addSelectionListener(new SelectionListener() {

			public void widgetSelected(SelectionEvent e) {
				lisTotPars.remove(lisTotPars.getSelectionIndex());
				boolean bvis = (lisTotPars.getItemCount() != 0);
				clearButton.setEnabled(bvis);
				removeButton.setEnabled(bvis);
				lisTotPars.setSelection(0);
				buildSignature();

			}

			public void widgetDefaultSelected(SelectionEvent e) {
			}

		});

		addButton.setText("Add");
		addButton.setLayoutData(buttonLayout(addButton));
		addButton.addSelectionListener(new SelectionListener() {

			public void widgetSelected(SelectionEvent e) {
				//               (new NewParamaterDialog(getShell(), parameters)).open();

				//lisTotPars.add(lisPars.getItem(lisPars.getSelectionIndex()));
				lisTotPars.add(lisPars.getText());
				clearButton.setEnabled(true);
				removeButton.setEnabled(true);
				String[] sel = new String[1];
				//sel[0] = lisPars.getItem(lisPars.getSelectionIndex());
				//lisTotPars.setSelection(sel);
				sel[0] = lisPars.getText();
				lisTotPars.setSelection(sel);
				buildSignature();

			}

			public void widgetDefaultSelected(SelectionEvent e) {
				lisTotPars.add(lisPars.getItem(lisPars.getSelectionIndex()));
			}

		});
		lisTotPars = new List(parametersGroup, 2052);
		gd = new GridData(768);
		gd.horizontalSpan = nColumns - 1;
		gd.verticalSpan = 3;
		lisTotPars.setLayoutData(gd);
 
		// init ctrls
		lisPars.add("boolean");
		lisPars.add("byte");
		lisPars.add("char");
		lisPars.add("int");
		lisPars.add("long");
		lisPars.add("float");
		lisPars.add("double");

		lisPars.add("java.lang.Boolean");
		lisPars.add("java.lang.Character");
		lisPars.add("java.lang.Byte");
		lisPars.add("java.lang.Double");
		lisPars.add("java.lang.Float");
		lisPars.add("java.lang.FloatingDecimal");
		lisPars.add("java.lang.Integer");
		lisPars.add("java.lang.Long");
		lisPars.add("java.lang.Number");
		lisPars.add("java.lang.Short");
		lisPars.add("java.lang.String");
		lisPars.add("java.util.Collection");

		clearButton.setEnabled(false);
		removeButton.setEnabled(false);
	}
	
	public boolean isPageValid() {
		return true;
	}

	protected void setStatus(IStatus status) {
		setPageComplete(status.isOK());
		if (status.getSeverity() == 4) {
			setErrorMessage(status.getMessage());
		} else {
			setErrorMessage(null);
			setMessage(
				"OK".equals(status.getMessage()) ? null : status.getMessage());
		}
	}

	public String getMethodName() {
		String s = name.getText();
		return name.getText();
	}

	private void buildSignature() {
		String msg = null;
		String rt = "";
		if (returnType != null)
			rt =
				(!returnType.getText().equals(""))
					? returnType.getText()
					: "??";

		String na = ""; //(!name.getText().equals("")) ? name.getText() : "??";
		String exc = "";

		if (methodType.equals("create")) {
			exc = " throws CreateException";
			na = "ejbCreate";
		}

		if (methodType.equals("find")) {
			exc = " throws FinderException";
			na = methodNameTxt0.getText();
			na = na.equals("") ? "ejbFindxxx" : na;
			// methodNameTxt0.setText(na);
		}

		if (methodType.equals("business")) {
			exc = " throws Exception";
			String zz = methodNameTxt.getText();
			na = methodNameTxt.getText();
			na = na.equals("") ? "Foo " : na;
			// methodNameTxt.setText(na);
		}

		String spars = "";
		for (int i = 0; i < lisTotPars.getItemCount(); i++) {
			if (i != 0)
				spars += ", ";
			spars += lisTotPars.getItem(i) + " par_" + i;
		}
		String s =
			methodPublic + " " + rt + " " + na + "(" + spars + ")" + exc + ";";
			
		// set Information message
		org.eclipse.core.runtime.IStatus status = new Status(4, "com.objectlearn.wlserver.integration.controlcenter", 4, "Return type is missign ..", new Exception());
		if (rt.equals ("??"))
			this.setStatus(status);

		

		name.setText(s);
		
	}

}
