/*
 * Created on Sep 18, 2003
 *
 */
package com.bull.eclipse.jonas.wizard;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import com.bull.eclipse.jonas.JonasLauncherPlugin;

/**
 * @author steve krupanszky
 *
 */

public class	CreateEJBWizardPage extends WizardPage implements ModifyListener
{

	private Button					createEJB;
	private Button					entButton1;
	private Button					entButton2;
	private Button					entButton3;
	private Button					mdbButton;
	private Button					deployUnit;
	public static final String	ENTITYb = "Entity, BMP";
	public static final String	ENTITYc1 = "Entity, CMP 1.x";
	public static final String	ENTITYc2 = "Entity, CMP 2.x";
	private Text					ejbnameText;
	private Composite				ejbtypeGroup;
	private Composite				ifcGroup;
	public static final String	INTEGER = "Integer";
	private Text					jarText;
	//private Text					jndiText;
	private String					jonasprojName;
	private Composite				keyGroup;
	private Label					keyLabel;
	private static 	Label 			ejbnameLabel;
	public static final String	LOCAL = "Local";
	public static final String	MDB = "MDB";
	protected static final String	DEPLOYUNIT = "Deploy Unit";
	public static final String	OBJECT = "Object";
	private String					pkg;
	private Text					pkgText;
	private Text					projText;
	public static final String	REMOTE = "Remote";
	private String					srcDir;
	private Text					srcfolderText;
	public static final String	STATEFUL = "Session, Stateful";
	public static final String	STATELESS = "Session, Stateless";
	public static final String	STRING = "String";

	public			CreateEJBWizardPage(String pageName)
	{
		super(pageName);
		setErrorMessage(null);
	}

	public void		createControl( Composite parent )
	{
		Composite composite = new Composite(parent, SWT.NULL);

		composite.setLayout(new GridLayout());
		composite.setLayoutData(new GridData(GridData.FILL_BOTH));

		createEJBGroup(composite);

		setMessage(null);
		setControl(composite);
		setPageComplete( validatePage() );

	}

	public void		createEJBGroup( Composite parent )
	{
		GridData		data;
		
		Composite ejbGroup = new Composite(parent,SWT.LEFT);
		GridLayout layout = new GridLayout();
		layout.numColumns = 2;
		ejbGroup.setLayout(layout);
		ejbGroup.setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );

	// Project Name
		Label projLbl = new Label( ejbGroup, SWT.LEFT );
		projLbl.setText("Jonas Project");

		projText = new Text(ejbGroup, SWT.BORDER);
		// preset this with the current selection's project name,
		// if it is a Jonas project
		data = new GridData(GridData.FILL_HORIZONTAL);
		projText.setLayoutData(data);
		if( jonasprojName!=null ) { projText.setText(jonasprojName); }
		projText.addModifyListener(this);

	// Source Folder (is not mandatory)
/*		Label srcfolderLabel = new Label( ejbGroup, SWT.LEFT );
		srcfolderLabel.setText("Source Folder");
		
		srcfolderText = new Text(ejbGroup,SWT.BORDER);
		data = new GridData(GridData.FILL_HORIZONTAL);
		srcfolderText.setLayoutData(data);
		srcDir = "components";
		srcfolderText.setEnabled(false);
		if( srcDir!=null ) { srcfolderText.setText(srcDir); }
*/
	// Package Name
		Label pkgLabel = new Label( ejbGroup, SWT.LEFT );
		pkgLabel.setText("Package");

		pkgText = new Text(ejbGroup,SWT.BORDER);
		data = new GridData(GridData.FILL_HORIZONTAL);
		pkgText.setLayoutData(data);
		if( pkg!=null ) { pkgText.setText(pkg); }

		pkgText.addModifyListener( new ModifyListener(){
			public void modifyText( ModifyEvent ev )
			{
				setPageComplete( validatePage() );
			}} );

	// EJB Name
		ejbnameLabel = new Label(ejbGroup,SWT.LEFT);
		ejbnameLabel.setText( "EJB name" );

		ejbnameText = new Text(ejbGroup,SWT.BORDER);
		data = new GridData(GridData.FILL_HORIZONTAL);
		data.widthHint = 12;
		ejbnameText.setLayoutData(data);
		ejbnameText.setText("");

		ejbnameText.addModifyListener( new ModifyListener(){
			public void modifyText( ModifyEvent ev )
			{
				setPageComplete( validatePage() );
			}} );
			
		// set the focus to the first empty text input box
		// FOCUS NOT WORKING TODAY (Eclipse 2.1)
		if( projText.getText().equals("") ) {
			projText.setFocus();
		} else if( pkgText.getText().equals("") ) {
			pkgText.setFocus();
		} else {
			ejbnameText.setFocus();
		}

	// JNDI Name (newbean has no provision to deal with this)
		//Label jndiLabel = new Label( ejbGroup, SWT.LEFT );
		//jndiLabel.setText("JNDI name");
		//jndiText = new Text(ejbGroup, SWT.BORDER);
		//data = new GridData(GridData.FILL_HORIZONTAL);
		//jndiText.setLayoutData(data);

	// Jar name
		new Label( ejbGroup, SWT.LEFT ).setText("Jar name");

		jarText = new Text(ejbGroup,SWT.BORDER);
		jarText.setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );

		jarText.addModifyListener( new ModifyListener(){
			public void modifyText( ModifyEvent ev )
			{
				setPageComplete( validatePage() );
			}} );

	// EJB Type
		Label ejbtypeLabel = new Label( ejbGroup, SWT.LEFT );
		ejbtypeLabel.setText("EJB type");

		ejbtypeGroup = new Composite( ejbGroup, SWT.NONE );
		layout = new GridLayout();
		layout.numColumns = 1;
		ejbtypeGroup.setLayout( layout );
		Button stateButton = new Button(ejbtypeGroup, SWT.RADIO);
		stateButton.setText(STATELESS);
		stateButton.setSelection(true); // choose a default selection
		new Button(ejbtypeGroup, SWT.RADIO).setText(STATEFUL);
		entButton1 = new Button(ejbtypeGroup, SWT.RADIO);
		entButton1.setText(ENTITYb);
		entButton2 = new Button(ejbtypeGroup, SWT.RADIO);
		entButton2.setText(ENTITYc1);
		entButton3 = new Button(ejbtypeGroup, SWT.RADIO);
		entButton3.setText(ENTITYc2);
		mdbButton = new Button(ejbtypeGroup, SWT.RADIO);
		mdbButton.setText(MDB);
		deployUnit = new Button(ejbtypeGroup, SWT.RADIO);
		deployUnit.setText(DEPLOYUNIT);

		
	// Interface Type
		final Label interfaceLabel = new Label( ejbGroup, SWT.LEFT );
		interfaceLabel.setText("Location");

		ifcGroup = new Composite( ejbGroup, SWT.NONE );
		layout = new GridLayout();
		layout.numColumns = 2;
		ifcGroup.setLayout( layout );
		Button localButton = new Button( ifcGroup, SWT.RADIO );
		localButton.setText(LOCAL);
		localButton.setSelection(true);
		new Button( ifcGroup, SWT.RADIO ).setText(REMOTE);
		SelectionAdapter sa1 = new SelectionAdapter() {
					public void widgetSelected(SelectionEvent ev) {
						if(!mdbButton.getSelection()) {
							ifcGroup.setVisible(true);
							interfaceLabel.setVisible(true);
						} else {
							ifcGroup.setVisible(false);
							interfaceLabel.setVisible(false);
						}
					}};

		SelectionAdapter deploySA1 = new SelectionAdapter() {
			public void widgetSelected(SelectionEvent ev) {
				if (!deployUnit.getSelection()) {
					ifcGroup.setVisible(true);
					interfaceLabel.setVisible(true);
					ejbnameText.setVisible(true);
					ejbnameLabel.setVisible(true);
				} else {
					ifcGroup.setVisible(false);
					interfaceLabel.setVisible(false);
					ejbnameText.setVisible(false);
					ejbnameLabel.setVisible(false);
				}
			}
		};
		mdbButton.addSelectionListener(sa1);
		deployUnit.addSelectionListener(deploySA1);

	// Primary Key (for entity beans)
		keyLabel = new Label( ejbGroup, SWT.LEFT );
		keyLabel.setText("Primary key class");
		keyLabel.setVisible(entityButtonSelected());

		keyGroup = new Composite( ejbGroup, SWT.NONE );
		layout = new GridLayout();
		layout.numColumns = 3;
		keyGroup.setLayout( layout );
		keyGroup.setVisible(entityButtonSelected());
		Button strButton = new Button(keyGroup, SWT.RADIO);
		strButton.setText(STRING);
		strButton.setSelection(true); // choose a default selection
		new Button(keyGroup, SWT.RADIO).setText(INTEGER);
		new Button(keyGroup, SWT.RADIO).setText(OBJECT);
		// add listener to EJBType to enable Primary Key selection
		SelectionAdapter sa2 = new SelectionAdapter() {
					public void widgetSelected(SelectionEvent ev) {
						if(entityButtonSelected()) {
							keyGroup.setVisible(true);
							keyLabel.setVisible(true);
						} else {
							keyGroup.setVisible(false);
							keyLabel.setVisible(false);
						}
					}};
		entButton1.addSelectionListener(sa2);
		entButton2.addSelectionListener(sa2);
		entButton3.addSelectionListener(sa2);

	}

	private boolean		entityButtonSelected()
	{
		return entButton1.getSelection()
			|| entButton2.getSelection()
			|| entButton3.getSelection();
	}

	public String		getEJBName()
	{
		return ejbnameText.getText().trim();
	}

	public String		getEJBType()
	{
		return getNameOfSelectedButton( ejbtypeGroup );
	}

	public String		getInterfaceName()
	{
		return getNameOfSelectedButton( ifcGroup );
	}

	public String		getJarName()
	{
		return jarText.getText().trim();
	}

/*	public String		getJNDIName()
	{
		return jndiText.getText();
	}
*/

	private String		getNameOfSelectedButton( Composite comp )
	{
		// return the text associated with the selected Button
		// of the specified Composite
		Control[]		buttons = comp.getChildren();
		if( comp.isVisible() ) {
			for( int i=0; i<buttons.length; i++ )
			{
				if( buttons[i] instanceof Button
				&& ((Button)buttons[i]).getSelection() ) {
					return ((Button)buttons[i]).getText();
				}
			}
		}
		return "NoButtonSelected";
	}

	public String		getPkgName()
	{
		return pkgText.getText().trim();
	}

	public String		getPrimaryKey()
	{
		return getNameOfSelectedButton( keyGroup );
	}

	public String		getProjName()
	{
		return projText.getText().trim();
	}

	public String		getSrcDir()
	{
		return srcfolderText.getText().trim();
	}

	private boolean		isJonasProject( String proj )
	{
		IProject	p;
		p = ResourcesPlugin.getWorkspace().getRoot().getProject(proj);
		try {
			return p.hasNature(JonasLauncherPlugin.NATURE_ID);
		}
		catch( CoreException e ) {}
		return false;
	}

	/** @see ModifyListener
	*/
	public void			modifyText( ModifyEvent ev )
	{
		setPageComplete( validatePage() );
	}

	public void			setProjName( String s )
	{
		jonasprojName = s;
	}

	public void			setPkg( String s )
	{
		pkg = s;
	}

	public void			setSrcDir( String s )
	{
		srcDir = s;
	}

	private boolean		validatePage()
	{
		return( ( ejbnameText != null
				&& getEJBName().length() > 0
				&& getPkgName().length() > 0
				&& getJarName().length() > 0
				&& getProjName().length() > 0
				&& isJonasProject( getProjName() )) || 
				(
				getEJBType().equals("Deploy Unit") 
				&& getPkgName().length() > 0
				&& getJarName().length() > 0
				&& getProjName().length() > 0
				&& isJonasProject( getProjName()
				))
				
			);
	}

}
